try:
    import simplegui
except ImportError:
    import SimpleGUICS2Pygame.simpleguics2pygame as simplegui

from Interaction import Interaction
from Room import Room

# Game file is for starting game functions using Interactions file
# Begins main game functions

class Game:
    FRAME_RATE = 60

    def create_frame(self):
        """Create the game frame and initialize the game.

        Returns:
            frame: The simplegui frame for the game
        """
        frame = simplegui.create_frame("dungeon diver", Room.CANVAS_WIDTH, Room.CANVAS_HEIGHT)
        game = Interaction()
        
        frame.set_draw_handler(game.draw)
        frame.set_keydown_handler(game.key_down)
        frame.set_keyup_handler(game.key_up)
        frame.set_mouseclick_handler(game.mouse_click)

        # Start the game loop
        def game_loop():
            """Timer function that updates the game state each frame."""
            game.update()

        timer = simplegui.create_timer(1000 // self.FRAME_RATE, game_loop)
        timer.start()
        
        return frame

GameObj = Game()
frame = GameObj.create_frame()
frame.start()