# Dungeon Diver Dave
A top-down, dungeon crawler, roguelike where the main character (Dave) progresses through randomly generated rooms, fight enemies, collect power-ups, and face bosses.

- Defeat all enemies to unlock the door to the next area.
- Each enemy kill scores you 100 points.
- Powerup abilities are lost after losing a live.
- Defeat 3 bosses to win the game.

# Controls
- WASD: Move up, left, down, right
- Spacebar: Attack
- R: Restart game (after game over)
- Left Mouseclick: Play button, and Restart button after completing the game.

# Use
## Locally
1. Using Python 3, in a virtual environment (recommended):
2. Install Programming Laboratory Module dependency: ```pip install SimpleGUICS2Pygame```
3. NOTE: Requires an internet connection to fetch game assets.
4. Run: ```python Game.py```

# Files overview
- Vector.py: Module code for Vector class.
- Entity.py: Defines all game entities - Player, Enemy, Boss, Obstacles, Powerup Items.
- Room.py: Handles room generation and everything contained in the room.
- Interaction.py: Manages game logic, UI.
- Game.py: Entry point that intialises the game and starts the game loop.